var NodeStack = /** @class */ (function () {
    function NodeStack() {
        this.members = new Set();
    }
    NodeStack.prototype.add = function (node) {
        !this.members.size && this.promote(node);
        this.members.add(node);
        node.scheduleRender();
    };
    NodeStack.prototype.promote = function (node, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.transfer, transfer = _c === void 0 ? "immediate" : _c;
        var prevLead = this.lead;
        this.lead = node;
        node.show();
        if (prevLead) {
            prevLead.scheduleRender();
            node.snapshot = prevLead.snapshot;
            node.isLayoutDirty = true;
            if (transfer === "immediate") {
                prevLead.hide();
            }
        }
    };
    return NodeStack;
}());

export { NodeStack };
